unit Unit1;

interface

uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
 Printers, StdCtrls, ExtCtrls;

type
 TForm1 = class(TForm)
  Label1: TLabel;
  Imprimantes: TListBox;
  Lister: TButton;
  Episode1: TButton;
  Episode2: TButton;
  Details: TMemo;
  Image1: TImage;
  Button1: TButton;
  Button2: TButton;
  procedure ListerClick(Sender: TObject);
  procedure Episode1Click(Sender: TObject);
  procedure ImprimantesClick(Sender: TObject);
  procedure Episode2Click(Sender: TObject);
  procedure Button1Click(Sender: TObject);
  procedure Button2Click(Sender: TObject);
 private
    { Dclarations prives }
 public
    { Dclarations publiques }
 end;
 
var
 Form1: TForm1;
 
implementation

{$R *.DFM}

procedure AngleTextOut(CV: TCanvas; const sText: string; x, y, angle: integer);
var
 LogFont: TLogFont;
 SaveFont: TFont;
begin
 SaveFont := TFont.Create;
 SaveFont.Assign(CV.Font);
 GetObject(SaveFont.Handle, sizeof(TLogFont), @LogFont);
 with LogFont do
  begin
   lfEscapement := angle * 10;
   lfPitchAndFamily := FIXED_PITCH or FF_DONTCARE;
  end; {with}
 CV.Font.Handle := CreateFontIndirect(LogFont);
 SetBkMode(CV.Handle, TRANSPARENT);
 CV.TextOut(x, y, sText);
 CV.Font.Assign(SaveFont);
 SaveFont.Free;
end;

procedure TForm1.ListerClick(Sender: TObject);
begin
 // Lister les imprimantes installes
 Imprimantes.Items := Printer.Printers;
 // Slectionner l'imprimante dfinie dans Windows
 Imprimantes.ItemIndex := Printer.PrinterIndex;
end;

procedure TForm1.ImprimantesClick(Sender: TObject);
begin
 Printer.PrinterIndex := Imprimantes.ItemIndex;
end;

procedure TForm1.Episode1Click(Sender: TObject);
var
 S: string;
begin
 with Printer do
  begin
   {Dmarrage de l'impression}
   BeginDoc;

   {Trac de la zone imprimable}
   Canvas.Rectangle(0, 0, PageWidth, PageHeight);

   {Dans chaque coin de la feuille, nous allons crire le texte 'Delphi c'est super'}
   S := 'Delphi c''est super';
   //Augmentons la taille de la fonte pour une meilleure vivibilit
   Canvas.font.Size := 12;
   // en haut  gauche
   Canvas.TextOut(0, 0, S);
   // en haut  droite
   Canvas.TextOut(PageWidth - Canvas.TextWidth(S), 0, S);
   // en bas  gauche
   Canvas.TextOut(0, PageHeight - Canvas.TextHeight(S), S);
  // en bas  droite
   Canvas.TextOut(PageWidth - Canvas.TextWidth(S), PageHeight - Canvas.TextHeight(S), S);
   // Enfin, au centre de la feuille
   Canvas.TextOut(round((PageWidth - Canvas.TextWidth(S)) / 2),
    round((PageHeight - Canvas.TextHeight(S)) / 2),
    S);

   {Envoi des commandes  l'imprimante}
   EndDoc;
  end;
 
end;

procedure TForm1.Episode2Click(Sender: TObject);
var
 H: integer;
 S: string;
 R: TRect;
begin
 // On place dans une variable le handle de l'imprimante
 H := Printer.handle;
 
 //La constante HORZSIZE nous fournit la largeur en millimtres
 Details.Lines.Add(format('Largeur zone imprimable en mm: %d',
  [GetDeviceCaps(H, HORZSIZE)]));
 //La constante VERTSIZE nous fournit la hauteur en millimtres
 Details.Lines.Add(format('Hauteur zone imprimable en mm: %d',
  [GetDeviceCaps(H, VERTSIZE)]));
 //La constante HORZRES nous fournit la largeur en pixels
 Details.Lines.Add(format('Largeur zone imprimable en mm: %d',
  [GetDeviceCaps(H, HORZRES)]));
 //La constante VERTRES nous fournit la hauteur en pixels
 Details.Lines.Add(format('Hauteur zone imprimable en mm: %d',
  [GetDeviceCaps(H, VERTRES)]));
 
 {
  Vous pouvez voir ici qu'il est maintenant facile de calculer le rapport entre
  les pixels et les millimtres sur votre page imprime
  1 pixel horizontal imprimante = GetDeviceCaps(H, HORZSIZE) / GetDeviceCaps(H, HORZRES)
 }
 
 {La constante PHYSICALOFFSETX nous fournit la taille en pixels de la zone
  non imprimable  partir du bord gauche de la feuille}
 Details.Lines.Add(format('pixels non imprimables  gauche: %d',
  [GetDeviceCaps(H, PHYSICALOFFSETX)]));
 
 {La constante PHYSICALOFFSETY nous fournit la taille en pixels de la zone
  imprimable  partir du bord gauche de la feuille}
 Details.Lines.Add(format('pixels non imprimables en haut: %d',
  [GetDeviceCaps(H, PHYSICALOFFSETY)]));
 
 
 R.Left := 10;
 R.Top := 10;
 S := 'Calcul rectangle avec DrawText';
 DrawText(Printer.handle, PChar(S), length(S), R, DT_CALCRECT);
 Details.Lines.Add(format('Largeur %d / Hauteur %D', [R.Right, R.Bottom]));
 
 //Rajoutons un saut de ligne pour voir la diffrence
 S := 'Calcul rectangle'#13'avec DrawText';
 DrawText(Printer.handle, PChar(S), length(S), R, DT_CALCRECT);
 Details.Lines.Add(format('Largeur %d / Hauteur %D', [R.Right, R.Bottom]));
 
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 H: integer;
 R: TRect;
begin
 H := image1.Canvas.handle;
 R := image1.ClientRect;
 DrawText(H, PChar('NORD'), length('NORD'), R, DT_TOP or DT_CENTER or DT_SINGLELINE);
 DrawText(H, PChar('CENTRE'), length('CENTRE'), R, DT_VCENTER or DT_CENTER or DT_SINGLELINE);
 DrawText(H, PChar('SUD'), length('SUD'), R, DT_BOTTOM or DT_CENTER or DT_SINGLELINE);
 DrawText(H, PChar('NORD_OUEST'), length('NORD_OUEST'), R, DT_TOP or DT_LEFT or DT_SINGLELINE);
 DrawText(H, PChar('OUEST'), length('OUEST'), R, DT_VCENTER or DT_LEFT or DT_SINGLELINE);
 DrawText(H, PChar('SUD_OUEST'), length('SUD_OUEST'), R, DT_BOTTOM or DT_LEFT or DT_SINGLELINE);
 DrawText(H, PChar('NORD_EST'), length('NORD_EST'), R, DT_TOP or DT_RIGHT or DT_SINGLELINE);
 DrawText(H, PChar('EST'), length('EST'), R, DT_VCENTER or DT_RIGHT or DT_SINGLELINE);
 DrawText(H, PChar('SUD_EST'), length('SUD_EST'), R, DT_BOTTOM or DT_RIGHT or DT_SINGLELINE);
 
 image1.Canvas.Font.Name := 'Times New Roman';
 AngleTextOut(image1.canvas, 'INCLINE', round(image1.width / 4),
  image1.Height, 90);
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 XCols: array[1..4] of integer;
 S: string;
 I, y, H: integer;
begin
 XCols[1] := 0;
 XCols[2] := round(image1.Width / 4);
 XCols[3] := round(image1.Width / 2);
 XCols[4] := image1.Width - XCols[2];
 
 y := 0;
 H := Image1.Canvas.TextHeight('M'); {la plus haute}
 for i := 0 to 5 do
  begin
   S := format('L%dC0'#9'L%dC1'#9'L%dC2'#9'L%dC3', [I, I, I, I]);
   TabbedTextOut(image1.Canvas.handle, 0, y, PChar(S), length(S), 4, XCols[1], 0);
   Y := Y + H + 2;
  end;
end;

end.

